/*
 * Copyright 2010-2020 JetBrains s.r.o. and Kotlin Programming Language contributors.
 * Use of this source code is governed by the Apache 2.0 license that can be found in the license/LICENSE.txt file.
 */

package org.jetbrains.kotlin.analysis.api.components

import org.jetbrains.kotlin.analysis.api.lifetime.withValidityAssertion
import org.jetbrains.kotlin.analysis.api.scopes.KtScope

public abstract class KtSymbolFromResolveExtensionProvider : KtAnalysisSessionComponent() {
    public abstract fun getResolveExtensionScopeWithTopLevelDeclarations(): KtScope
}

public interface KtSymbolFromResolveExtensionProviderMixIn : KtAnalysisSessionMixIn {
    /**
     * Returns [KtScope] which contains all top-level callable declarations which are generated by [org.jetbrains.kotlin.analysis.api.resolve.extensions.KtResolveExtension]
     *
     * @see org.jetbrains.kotlin.analysis.api.resolve.extensions.KtResolveExtension
     * @see org.jetbrains.kotlin.analysis.api.resolve.extensions.KtResolveExtensionProvider
     */
    public fun getResolveExtensionScopeWithTopLevelDeclarations(): KtScope = withValidityAssertion {
        analysisSession.resolveExtensionProvider.getResolveExtensionScopeWithTopLevelDeclarations()
    }
}
